# THIS IS NO FUNCTION. THIS IS THE MAIN PROGRAM
#' Information to directories and so on:
#' - The names of file which should be read in are written
#'    down in a text file. The files name should be
#'    $fInListNameBase$country . E.g. if fInListNameBase is 'all_files_' and
#'    country is 'UK', the file should be named 'all_files_UK'.
#' - The above mentioned file should be located in the directory
#'    dInListName.
#' - The files which are listed in the above mentioned file should
#'    be located in $dDataBase/$country (=$dDataFull) or in the manually
#'    set $dDataFull
#' 
#' Thus one needs to adjust:
#' - fInListNameBase
#' - country
#' - dDataBase
#' 
#' 
#' @author Daniel Neumann, Helmholtz-Zentrum Geesthacht
#'    \email{daniel.neumann@hzg.de}
#' @date 2015-12-04
#' @version 13.0
#' @format R Code


# set working directory ----
# wd <- "/media/Eigene\ Dateien/11_Arbeit/65_R/emep_final_parserANDdatabase"
# wd <- "~/emep_database/emep_final_parserANDdatabase"
wd = '/DVD/supplement/TOOLS/EMEP_DATABASE'
setwd(wd)


# load libraries and source R scripts ----
library("RODBC")
source("./emep_file_tools.R")   # NEW_v13_000
source("./emep_file_parser.R")    # NEW_v13_000
source("./emep_database_parser.R")  # NEW_v13_000


# Set File and Directory Names ----
## country code
country="FR"

## base directory name of the EMEP text files to import into the database;
## commonly eqauls the directory of the file containing the file name list
##   for import;
# dDataBase = "~/emep_database/files"
dDataBase = "/media/neumannd/work_mn/64_EMEP/ebas_2015"
dDataBase = "/home/neumannd/Downloads/Ebas_151216_1223"
# dDataBase = "."

## base name of the file containing text file names to import
## into the database
fInListNameBase = "all_files_"
# fInListNameBase = "reread_files_"

## full name of the file containing text file names to import
## into the database
fInListNameFull = paste(fInListNameBase, country, sep="")
# fInListNameFull = "test_files"
# fInListNameFull = "auswahl05_files"
# fInListNameFull = paste(fInListNameBase, 'all_countries', sep="")

## full directoy name of the file containing text file names to
## import into the database
# dInListName = "."
# dInListName = dDataFull
dInListName = dDataBase

## full directory name of the EMEP text files to import into the database
dDataFull = paste(dDataBase, country, sep="/")
# dDataFull = dDataBase
# dDataFull = "testfiles"
# dDataFull = "testfiles/DB_2015"

## file handle to the file containing the list of file names for the
## database import
fileHandleInListName <- file(
  #paste(dInListName, paste(fInListNameBase, country, sep=""), sep="/"), 
  paste(dInListName, fInListNameFull, sep="/"), 
  open="rt"
)

## file names of the error log and general log files
fileOutError = paste(wd, paste("log_error_", country, ".dat", sep=""), sep="/")
fileOutInfo = paste(wd, paste("log_info_", country, ".csv", sep=""), sep="/")


# get number of input files ----
# count lines in file 1
if (isOpen(fileHandleInListName)) {
  nRows = 0
  while (length(readLines(fileHandleInListName, n=1)) > 0) {
    nRows = nRows + 1
  }
  # close and re-open file to reset the line pointer to 1
  close(fileHandleInListName)           # close file
  fileHandleInListName <- file(         # re-open file
    paste(dInListName, fInListNameFull, sep="/"),  # open file dInListName/fNameIn
    open="rt"                     # open as read-only
  )
}


# no list of input files available ----
## NEW_v12_103 ; START; changes in structure; no OLD version kept
#file.remove(fileOutError)
if (!file.exists(fileOutInfo)) { # NEW_v13_000
  # file.remove(fileOutInfo)
  write(paste('filename', 
              'elapsed time', 
              'inserted times series', 
              'read times series',
              'inserted data points',
              'read data points',
              'error (!= 0)',
              ";", sep=", "
              ),
        file=fileOutInfo, ncolumns=1, append=TRUE
        )
## NEW_v12_103 ; END; changes in structure; no OLD version kept
}


# db import ----
## Uncomment if one does not want to start in the beginning of the list-file.
#tmp=scan(fileHandleInListName, what=character(), nlines=6891, quiet=TRUE)
for (i1 in 1:nRows) {
  # db import: read single file names ----
  print(i1)
  fName=scan(fileHandleInListName, what=character(), nlines=1, quiet=TRUE)
  print(fName)
  
  
  # db import: do import ----
  ## Save current time to calculate runtime later
  startTime <- proc.time()
  
  ## define and open database connection
  myCon <- odbcConnect(dsn="neumannd-pg-emep_v02.1", uid="neumannd", pwd="nd$1,") # NEW_v12_104
  # myCon <- odbcConnect(dsn="emep_test_db", uid="neumannd", pwd="neumannd")
  
  ## add file content to db
  outList <- add_file(myCon, fName, dDataFull, TRUE)
  # NOTE: If you want to be sure, that no double entries are inserted, set the
  #       fourth parameter to FALSE or do not parse any value (standard is 
  #       FALSE).
  
  ## close db connection
  close(myCon)
  
  ## Stop time
  endTime <- proc.time()
  
  
  # db import: write into log files ----
  ## Construct Output String
  if (outList$err_file == 0) {
    read_file = "1"
    new_file = as.integer(1)
  } else {
    new_file = as.integer(0)
    if (outList$err_file==4) { # ToDo: Change; WHY???
      read_file="No"
    } else {
      read_file="1"
    }
  }
  
  outString_l1 = "----------"
  outString_l2 = paste(fName, ", ", outList$err_file, sep="")
  outString_l3 = outList$file_insert_return
  outString_l4 = ""
  for (i2 in 1:length(outList$substances_short)) {
    outString_l4 = paste(outString_l4, ", ", outList$substances_short[i2], " ", outList$errs_measurement[i2], sep="")
  }
  
  outString_l5 = paste(read_file, " file was read in containing ", outList$n_measurement, " variables over ", outList$new_data, " time steps each. \n",
                    outList$new_file , " of ", 1, " files and meta data sets were INSERTEd in table FILES. \n",
                    outList$new_measurement , " of ", outList$n_measurement, " variables were UPDATEd in table MEASUREMENTS. \n",
                    outList$new_data, " of ", outList$n_data, " data sets (/measurement values) were UPDATEd in table DATA. ", 
                    ";; ", sep="")
  ## FINISHED CONSTRUCTION OUTPUT STRINGs
  
  ## Collect Errors
  err = 0
  if (length(which(outList$err==0))<length(outList$err)) err = err + 1
  if (length(which(outList$err_file==0))<length(outList$err_file)) err = err + 1
  if (length(which(outList$err_measurement==0))<length(outList$err_measurement)) err = err + 1
  if (length(which(outList$err_data==0))<length(outList$err_data)) err = err + 1

  ## WRITE OUT IF ERROR
  if (err > 0) {
    write(outString_l1, file=fileOutError, ncolumns=1, sep=";", append=TRUE)
    write(outString_l2, file=fileOutError, ncolumns=1, sep=";", append=TRUE)
    write(outString_l3, file=fileOutError, ncolumns=1, sep=";", append=TRUE)
    write(outString_l4, file=fileOutError, ncolumns=1, sep=";", append=TRUE)
    write(outString_l5, file=fileOutError, ncolumns=1, sep=";", append=TRUE)
  }
  
  ## NEW_v12_105
  ## Write out diagnostic CSV file.
  write(paste(
    fName, 
    formatC((endTime-startTime)[['elapsed']], digits=2,format='f'), 
    formatC(outList$new_measurement, format='d'), 
    formatC(outList$n_measurement, format='d'),
    formatC(outList$new_data, format='d'),
    formatC(outList$n_data, format='d'),
    formatC(err, format='d'),
    ";", sep=", "
    ),
        file=fileOutInfo, ncolumns=1, append=TRUE
        )
  ## NEW_v12_105
  
  ## Calculate and print the run time in seconds.
  print(endTime-startTime)
  print("-----------")
  print("-----------")
}

# db import: close file input list file ----
close(fileHandleInListName)
