#!/bin/bash

# TODO
# @author Daniel Neumann, daniel.neumann@hzg.de
# @date 2016-01-05

# set gmt parameters
gmtdefaults -D > .gmtdefaults4
gmtset MAP_ORIGIN_X 3c MAP_ORIGIN_Y 5.0c
#gmtset MAP_ORIGIN_X 3c MAP_ORIGIN_Y 9.0c
#gmtset HEADER_FONT_SIZE 16p
gmtset FONT_TITLE 14p
gmtset FONT_LABEL 20p
gmtset FONT_ANNOT_PRIMARY 18p
# Label with -/+:
gmtset FORMAT_GEO_MAP ddd:mm:ss
#Labels with East and West


cd /media/neumannd/work_mn/66_Tools/plots_aq2016
DATADIR='02_data_version2'
PICDIR='05_maps'
fileName='fig01_station_map_version2'

# parameters
echo "Creating Map" 
WEST=-10.0
EAST=30.0
SOUTH=42.0
NORTH=66.0
DLON=5.0 # dx
DLAT=4.0 # dy
PARAMS=""

# map
pscoast -R$WEST/$EAST/$SOUTH/$NORTH -JM14 $PARAMS -B$DLON/$DLAT -Glightyellow -Slightblue -P -Dh -Lf-3/64.8/56/400k+l'km' -K > pic.ps
# compas: -Tf3/64.2/1.0/ 

psxy ${DATADIR}/stations.tab -R -J -Sc0.1i -Gblack -O -K >> pic.ps
psxy ${DATADIR}/stations.tab -R -J -Sc0.02i -Gwhite -O -K >> pic.ps
psxy ${DATADIR}/stations.conc.tab -R -J -Sc0.1i -Gorange -O -K >> pic.ps
psxy ${DATADIR}/stations.wetdep.tab -R -J -Sc0.1i -Gblue -O -K >> pic.ps
# psxy ${DATADIR}/stations.wetdep.tab -R -J -Si0.1i -Ggreen -O -K >> pic.ps


# awk '{printf "%g %s 12 0 1 CB %s\n", $1, $2+0.3, $3}' ${DATADIR}/stations.top.tab | pstext -R -J -O -K -N >> pic.ps
# awk '{printf "%g %s 12 0 1 CT %s\n", $1, $2-0.4, $3}' ${DATADIR}/stations.below.tab | pstext -R -J -O -K -N >> pic.ps
# awk '{printf "%g %s 12 0 1 RM %s\n", $1-0.5, $2, $3}' ${DATADIR}/stations.left.tab | pstext -R -J -O -K -N >> pic.ps
# awk '{printf "%g %s 12 0 1 LB %s\n", $1, $2-0.5, $3}' ${DATADIR}/stations.botright.tab | pstext -R -J -O -K -N >> pic.ps
# awk '{printf "%g %s 12 0 1 LT %s\n", $1, $2+0.5, $3}' ${DATADIR}/stations.topright.tab | pstext -R -J -O -K -N >> pic.ps
# awk '{printf "%g %s 12 0 1 LM %s\n", $1+0.5, $2, $3}' ${DATADIR}/stations.right.tab | pstext -R -J -O -N >> pic.ps
pstext ${DATADIR}/stations.names.top.tab -R -J -F+a0+f12,1,black+jCB -Dj0.0c/0.2c -O -K -N >> pic.ps
pstext ${DATADIR}/stations.names.left.tab -R -J -F+a0+f12,1,black+jRM -Dj0.2c/0.0c -O -K -N >> pic.ps
pstext ${DATADIR}/stations.names.right.tab -R -J -F+a0+f12,1,black+jLM -Dj0.2c/0.0c -O -K -N >> pic.ps
pstext ${DATADIR}/stations.names.botright.tab -R -J -F+a0+f12,1,black+jLT -Dj0.1c/0.1c -O -K -N >> pic.ps
pstext ${DATADIR}/stations.names.topright.tab -R -J -F+a0+f12,1,black+jLB -Dj0.1c/0.1c -O -K -N >> pic.ps
pstext ${DATADIR}/stations.names.topleft.tab -R -J -F+a0+f12,1,black+jRB -Dj0.1c/0.1c -O -K -N >> pic.ps
pstext ${DATADIR}/stations.names.bot.tab -R -J -F+a0+f12,1,black+jCT -Dj0.0c/0.2c -O -N >> pic.ps


## convert into other formats
ps2raster -A -Teg -Qt2 pic.ps
mv pic.png ${PICDIR}/$fileName.png
mv pic.eps ${PICDIR}/$fileName.eps
cp pic.ps ${PICDIR}/$fileName.ps

echo 'finished'
