# Function to plot color bar
# from http://stackoverflow.com/questions/9314658/colorbar-from-custom-colorramppalette
# and http://www.colbyimaging.com/wiki/statistics/color-bars
color.bar <- function(lut, min, max=-min, nticks=11, ticks=seq(min, max, len=nticks), title='') {
  scale = (length(lut)-1)/(max-min)
  
  dev.new(width=1.75, height=5)
  plot(c(0,10), c(min,max), type='n', bty='n', xaxt='n', xlab='', yaxt='n', ylab='', main=title)
  axis(2, ticks, las=1)
  for (i in 1:(length(lut)-1)) {
    y = (i-1)/scale + min
    rect(0,y,5,y+1/scale, col=lut[i], border=NA)
  }
}


# Function to plot color bar
color.barMod <- function(lut, min, max=-min, nticks=11, ticks=seq(min, max, len=nticks), title='') {
  # scale = (length(lut)-1)/(max-min)
  scale = (length(lut)-1)/(max-min)
  
  dev.new(width=1.75, height=5)
  par(adj = 0.6)
  plot(c(0,10), c(-(max-2*min),max), type='n', bty='n', xaxt='n', xlab='', yaxt='n', ylab='')
  title(title, line = 0)
  axis(4, ticks, las=1, pos = 5.5, lwd = 0, lwd.tick = 4, font = 2, cex.axis = 1.2)
  for (i in 1:(length(lut)-1)) {
    y = (i-1)/scale + min
    rect(4,y,5.5,y+1/scale, col=lut[i], border=NA)
  }
}

# color.barMod(rainbow(60)[42:1], min = 0, max = 5, nticks = 16)