#!/bin/bash

# two map
# By this script, one plo containing two maps and a legend are created.
# Original data: /media/work_mn/66_Tools/nsr_sail_eu/chosen_routes
# @author Daniel Neumann, daniel.neumann@hzg.de
# @date 2015-03-04

# set directories
cd /media/work_mn/66_Tools/pub_neumannd2015a
DATADIR='01_data'
PICDIR='05_maps'
fileName='fig01_cmaq_grids_pub'

# set gmt parameters
gmtdefaults -D > .gmtdefaults4
gmtset X_ORIGIN 3c Y_ORIGIN 5.0c
#gmtset X_ORIGIN 3c Y_ORIGIN 9.0c
#gmtset HEADER_FONT_SIZE 16p
gmtset HEADER_FONT_SIZE 14p
gmtset LABEL_FONT_SIZE 20p
gmtset ANOT_FONT_SIZE 18p
# Label with -/+:
gmtset PLOT_DEGREE_FORMAT ddd:mm:ss
#Labels with East and West
#gmtset PLOT_DEGREE_FORMAT F


# parameters
WEST=-30 # WEST=-40
EAST=50.0 # EAST=55.0
SOUTH=25.0
NORTH=75.0
DLON=10.0 # dx
DLAT=5.0 # dy
PARAMS=""
POINTS="CD06"

# map
# pscoast -R$WEST/$EAST/$SOUTH/$NORTH -JM9 $PARAMS -B$DLON/$DLAT -Glightyellow -W1p -P -Slightblue -Df -Tf8/51.1/1.2/:: -Lf-4/63.2/56/400k+l'km' -K > pic.ps
pscoast -R$WEST/$EAST/$SOUTH/$NORTH -JL10.0/55.0/30.0/60.0/20 $PARAMS -B$DLON/${DLAT}'WESn' -Glightyellow -W1p -Slightblue -Dl -K > pic.ps

# data
psxy ${DATADIR}/CD72_LON_LAT.grid -R -I0.7 -JL10.0/55.0/30.0/60.0/20 -m -O -K >> pic.ps
psxy ${DATADIR}/CD24_LON_LAT.grid -R -I0.7 -JL10.0/55.0/30.0/60.0/20 -m -O -K >> pic.ps
# psxy ${DATADIR}/CD06_LON_LAT.grid -R -I0.7 -JL10.0/55.0/30.0/60.0/20 -m -O -K >> pic.ps

pscoast -R$WEST/$EAST/$SOUTH/$NORTH -JL10.0/55.0/30.0/60.0/20 $PARAMS -W1p -Dl -O -K >> pic.ps

## LEGEND
# psscale -Cpowersaving.cpt -S -D5/0/10/1ch -B1000:'power savings':/:'low': -Al -X2.2 -Y-2.2 -N -O -K >> pic.ps
#pstext -J -R -O -X0 -Y0 -N -K << EOF >> pic.ps
#-2 49.2 18 0 0 MC high
#EOF

cat > my.legend << END
S 0.1i c 0.15i blue 0.25p 0.2i 72 x 72 km2
S 0.1i c 0.15i green 0.25p 0.2i 24 x 24 km2
END
# S 0.1i c 0.15i blue 0.25p 0.2i CD72 (72x72 km2)
# S 0.1i c 0.15i green 0.25p 0.2i CD24 (24x24 km2)
# S 0.1i c 0.15i red 0.25p 0.2i CD06 (6x6 km2)

pslegend my.legend -D+10/200/4.5/1.7/LB -R -JL10.0/55.0/30.0/60.0/2 -F -Gwhite -O >> pic.ps


## convert into other formats
ps2raster -A -Teg -Qt2 pic.ps
mv pic.png ${PICDIR}/$fileName.png
mv pic.eps ${PICDIR}/$fileName.eps
cp pic.ps ${PICDIR}/$fileName.ps

echo 'finished'
