library('ncdf4')

## LOCATION E (E wie Emil) IS USED IN THE PAPER!!!

#' original: combine_sim_and_obs_v1.6.0_newPlotOrder.R
## save(list = ls(all=TRUE), file = "inData_ssemis_timeSeries.RData")
## load("inData_ssemis_timeSeries.RData")

source('./handy_functions.R')
source('../../65_R/78_tools/getYlim.R')
source('../../65_R/78_tools/make_daily_mean.R')

# Create plots for Daniel's extended Abstract for the ITM 2015 in Montpellier.
getSimData = FALSE
workData = FALSE
plotData = FALSE
boxPlots = FALSE
pubPlots = FALSE
plotType = 2 # 1 == lines/steps; 2 == points; 
writeOutData = TRUE

setup='effectSeaSalt.v5'
strYear='2008'
# strYear='2013'
mech = 'cb05tucl_ae5_aq_ssa'


if(setup == 'seasalt3d') {
  ssSO4Mass = 0.0776
  ssNaMass = 0.3086
  ssClMass = 0.5538
  ssSeaCatMass = 0.3086+0.0368+0.0114+0.0118
} else if (setup == 'effectSeaSalt') {
  ssSO4Mass = 0.0755
  ssNaMass = 0.3856
  ssRealNa2Cat = 0.7800
  ssClMass = 0.5389
} else if (setup == 'effectSeaSalt.v5') {
  ssSO4Mass = 0.0755
  ssNaMass = 0.3856
  ssRealNa2Cat = 0.7800
  ssClMass = 0.5389
}


# set some parameters ----
inDir = '/ocean-storage/neumannd/data/cctm/CD24/analysis'
inOcean = '/ocean-storage/M3HOME/data/ocean/sf050m_GIS/OCEAN_CD24_sf050m_GIS_ubound.nc'

MONs = c('win2008', 'sum2008')
# SPECs = paste(rep(c('NUM', 'MASS'), each = 2), rep(c('J','K'), 2), sep = '')
allSPECs = c(paste(rep(c('ACL', 'ANA', 'ASO4'), each = 3), rep(c('I', 'J','K'), 3), sep = ''),
             paste(rep(c('NUM', 'SRF'), each = 3), rep(c('ATKN', 'ACC','COR'), 2), sep = ''))
# myStations = c("D", "E", "F", "A", "B", "C")
myCells = list('D' = list('x'=35, 'y'=60), # high North Sea; lon=0.466004 ; lat=56.8584
               'E' = list('x'=50, 'y'=45), # German Bight; lon=6.72055; lat=53.829
               'F' = list('x'=65, 'y'=48), # Baltic Sea; lon=12.3765 ; lat=54.5109
               'A' = list('x'=46, 'y'=43),
               'B' = list('x'=53, 'y'=44),
               'C' = list('x'=47, 'y'=77))
myStations = names(myCells)
nSTATIONS = length(myStations)
# SCENs = c('base', 'noSurf')
SCENs = c('base', 'sp13.corr', 'ov14.corr', 'zero')
# SCENs = c('base', 'noSurf', 'zero', 'full')

# GRID CORNERS, D
# (=0.242906,=56.9539)
#                 (=0.641529,=56.98)
# (=0.291452,=56.7366)
#                 (=0.688128,=56.7626)

# GRID CORNERS, E
# (6.52525,53.9348)
#                 (6.9005,53.9439)
# (6.54147,53.7138)
#                 (6.91497,53.7229)

if (getSimData) {
  valSIM = list()
  for(iMon in MONs) {
    valSIM[[iMon]] = list()
    for(iScen in SCENs) { valSIM[[iMon]][[iScen]] = list() }
  }
}


# get data ----
if (getSimData) {
  print('  READING ocean File')
  ncId = nc_open(inOcean)
  valOpen = ncvar_get(ncId, 'OPEN')
  valSurf = ncvar_get(ncId, 'SURF')
  nc_close(ncId)
  print('  finished READING ocean File')

  for(iMon in MONs) {
    if(iMon == 'sum2008' || iMon == 'sum') {
      nT = 61
      from = 2008183
      to = 2008243
    } else if(iMon == 'win2008' || iMon == 'win') {
      nT = 60
      from = 2008001
      to = 2008060
    }
    nTh = nT * 24
    
    print('~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~')
    print('READING SIMULATION DATA FROM NETCDF FILES')
    print('~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~')
    
    for(iScen in SCENs) {
      print(paste('  READING netCDF files for scenario ', iScen, sep = ''))
      ncId = nc_open(paste(inDir, paste('SSEMIS2.CD24_', setup, '.', iScen,
                                        '_', mech, '_', iMon, '.short', sep = ''), 
                           sep = '/'))
      
      for (iSpec in allSPECs) {
        print(paste('    Reading', iSpec, sep = ' '))
        if (iScen %in% c('base', 'zero', 'noSurf', 'surf', 'full') && tail(strsplit(iSpec, '')[[1]], n = 1) %in% c('I','N')) {
          if (tail(strsplit(iSpec, '')[[1]], n = 1) == 'I') newSpec = sub('I', 'J', iSpec)
          if (tail(strsplit(iSpec, '')[[1]], n = 1) == 'N') newSpec = sub('ATKN', 'ACC', iSpec)
          valSIM[[iMon]][[iScen]][[iSpec]] = 0.0 * matrix(ncvar_get(ncId, newSpec)[array(c(rep(t(array(unlist(myCells), dim = c(2,nSTATIONS))),each=nTh),rep(1:nTh, nSTATIONS)), dim = c(nTh*nSTATIONS,3))], ncol=nSTATIONS) 
        } else {
          valSIM[[iMon]][[iScen]][[iSpec]] = matrix(ncvar_get(ncId, iSpec)[array(c(rep(t(array(unlist(myCells), dim = c(2,nSTATIONS))),each=nTh),rep(1:nTh, nSTATIONS)), dim = c(nTh*nSTATIONS,3))], ncol=nSTATIONS)
        }
      }
      
      nc_close(ncId)
    }
  }
}


if(workData) {
  for(iMon in MONs) {
    for(iScen in SCENs) {
      # mass
      valSIM[[iMon]][[iScen]]$MASSATKN = valSIM[[iMon]][[iScen]]$ACLI + valSIM[[iMon]][[iScen]]$ANAI + valSIM[[iMon]][[iScen]]$ASO4I
      valSIM[[iMon]][[iScen]]$MASSACC = valSIM[[iMon]][[iScen]]$ACLJ + valSIM[[iMon]][[iScen]]$ANAJ + valSIM[[iMon]][[iScen]]$ASO4J
      valSIM[[iMon]][[iScen]]$MASSCOR = valSIM[[iMon]][[iScen]]$ACLK + valSIM[[iMon]][[iScen]]$ANAK + valSIM[[iMon]][[iScen]]$ASO4K
      valSIM[[iMon]][[iScen]]$MASST = valSIM[[iMon]][[iScen]]$MASSATKN + valSIM[[iMon]][[iScen]]$MASSACC + valSIM[[iMon]][[iScen]]$MASSCOR
      
      # volume in m^3
      valSIM[[iMon]][[iScen]]$VOLATKN = (valSIM[[iMon]][[iScen]]$ACLI/2.2 + valSIM[[iMon]][[iScen]]$ANAI/2.2 + valSIM[[iMon]][[iScen]]$ASO4I/1.8)/10^6
      valSIM[[iMon]][[iScen]]$VOLACC = (valSIM[[iMon]][[iScen]]$ACLJ/2.2 + valSIM[[iMon]][[iScen]]$ANAJ/2.2 + valSIM[[iMon]][[iScen]]$ASO4J/1.8)/10^6
      valSIM[[iMon]][[iScen]]$VOLCOR = (valSIM[[iMon]][[iScen]]$ACLK/2.2 + valSIM[[iMon]][[iScen]]$ANAK/2.2 + valSIM[[iMon]][[iScen]]$ASO4K/1.8)/10^6
      valSIM[[iMon]][[iScen]]$VOLT = valSIM[[iMon]][[iScen]]$VOLATKN + valSIM[[iMon]][[iScen]]$VOLACC + valSIM[[iMon]][[iScen]]$VOLCOR
      
      # Number and Surface
      valSIM[[iMon]][[iScen]]$SRFT = valSIM[[iMon]][[iScen]]$SRFATKN + valSIM[[iMon]][[iScen]]$SRFACC + valSIM[[iMon]][[iScen]]$SRFCOR
      valSIM[[iMon]][[iScen]]$NUMT = valSIM[[iMon]][[iScen]]$NUMATKN + valSIM[[iMon]][[iScen]]$NUMACC + valSIM[[iMon]][[iScen]]$NUMCOR
      
      # mu and sigma
      for(iMode in c('ATKN', 'ACC', 'COR')) {
        M0 = valSIM[[iMon]][[iScen]][[paste('NUM',iMode, sep = '')]]
        M2 = valSIM[[iMon]][[iScen]][[paste('SRF',iMode, sep = '')]] / pi
        M3 = valSIM[[iMon]][[iScen]][[paste('VOL',iMode, sep = '')]] * 6 / pi
        strSTD = paste('STD', iMode, sep = '')
        strGMD = paste('GMD', iMode, sep = '')
        
        lnSTDsq = ( log(M0) + 2*log(M3) - 3*log(M2) )/3
        valSIM[[iMon]][[iScen]][[strSTD]] = sqrt( exp(lnSTDsq) )
        valSIM[[iMon]][[iScen]][[strGMD]] = (M3/(M0 * exp(9/2 * lnSTDsq)))^(1/3)
      }
    }
    
  }
}

# plot data ----
if(plotData) {  
  # plot data: define output file type ----
  # postscript(file = paste('CONC.timeseries.', setup, '.ps', sep = ''), onefile=TRUE,
  #            horizontal = FALSE, paper = 'special', width = 10, height = 6.5)
  
  # par(mar = c(0,0,0,0)+0, 
  #     mgp = c(1.5,0.5,0.0))
  
  rowAxisTxt = list('ATKN'='Aitken mode', 'ACC' = 'accumulation mode', 'COR' = 'coarse mode')
  yAxisLab = list('NUMATKN' = expression('Atkn. mode particle number flux ['*10^19 ~ 'particles/d]'),
                  'NUMACC' = expression('acc. mode particle number flux ['*10^19 ~ 'particles/d]'),
                  'NUMCOR' = expression('coarse mode particle number flux ['*10^19 ~ 'particles/d]'),
                  'NUMT' = expression('particle number flux ['*10^19 ~ 'particles/d]'),
                  'SRFATKN' = expression('Atkn. mode particle surface area flux [m^2/d]'),
                  'SRFACC' = expression('acc. mode particle surface area flux [m^2/d]'),
                  'SRFCOR' = expression('coarse mode particle surface area flux [m^2/d]'),
                  'SRFT' = expression('particle surface area flux [m^2/d]'),
                  'MASSATKN' = expression('Atkn. mode particle mass flux [t/d]'),
                  'MASSACC' = expression('acc. mode particle mass flux [t/d]'),
                  'MASSCOR' = expression('coarse mode particle mass flux [t/d]'),
                  'MASST' = expression('particle mass flux [t/d]'),
                  # 'GMDT' = expression('geometric mean diameter ['*mu*'m]'),
                  'GMDT' = expression('GMD ['*mu*'m]'),
                  # 'STDT' = expression('standard deviation'),
                  'STDT' = expression('standard deviation' ~ sigma))
  yScale = list('NUMATKN' = 8.64*10^-15, 'NUMACC' = 8.64*10^-15, 'NUMCOR' = 8.64*10^-15, 'NUMT' = 8.64*10^-15, 
                'SRFATKN' = 1, 'SRFACC' = 1, 'SRFCOR' = 1, 'SRFT' = 1, 
                'MASSATKN' = 0.0864, 'MASSACC' = 0.0864, 'MASSCOR' = 0.0864, 'MASST' = 0.0864)
  yMaxVals = list('NUMATKN' = 80, 'NUMACC' = 10, 'NUMCOR' = 1, 'NUMT' = 10, 
                  'MASSATKN' = 0.1, 'MASSACC' = 2, 'MASSCOR' = 140, 'MASST' = 140)
  
  
  # plot data: define screens ----
  ShlB = 0.0981 # 0.07 # left
  ShrB = 0.9925 # 0.992 # right
  ShdB = 0.0698 # 0.035 # Abstand
  SvtB = 0.93 # top
  SvbB = 0.05 # bottom
  SvdB = 0.01 # Abstand
  ShBox = 0.06
  
  ShcB = ShlB+(ShrB-ShlB)*3/6 # center
  ShwB = ShrB-ShlB # width
  
  for(iLoc in c(1)){
  # for(iLoc in 1:3){
    iStat = myStations[[iLoc]]
    myLoc = myCells[[iStat]]
    
    # postscript(file = paste('SSEMIS.timeseries', setup, iStat, 
    #                         gsub('([0-9]{2}).([0-9]{2})', 'x\\1y\\2', paste(unlist(myLoc), collapse = '.')),
    #                         'ps', sep = '.'), onefile=TRUE,
    #            horizontal = FALSE, paper = 'special', width = 10.7, height = 6.5)  # width = 10
    
    # par(mar = c(0,0,0,0)+0, 
    #     mgp = c(1.5,0.6,0.0))
    
    for(iType in c('NUM', 'SRF', 'MASS', 'GMD')) {
    # for(iType in c('NUM', 'SRF', 'MASS', 'GMD', 'STD')) {
      
      pdf(file = paste(paste('figS03toS06_SSEMIS_timeseries', sub('.', '_', setup, fixed = TRUE), iStat, iType, 
                             gsub('([0-9]{2}).([0-9]{2})', 'x\\1y\\2', paste(unlist(myLoc), collapse = '_')),
                             sep = '_'), 'pdf', sep = '.'), onefile=TRUE,
          paper = 'special', width = 10.7, height = 6.5)  # width = 10
      
      par(mar = c(0,0,0,0)+0, 
          mgp = c(1.5,0.6,0.0))
      
      split.screen(rbind(c(ShlB,ShrB, SvtB+SvdB, 1.0-SvdB), # legend row
                         # top left, time series
                         c(ShlB, ShcB-ShdB/2-ShBox, SvbB+(SvtB-SvbB)*2/3+SvdB/2, SvtB),
                         c(ShcB-ShdB/2-ShBox, ShcB-ShdB/2, SvbB+(SvtB-SvbB)*2/3+SvdB/2, SvtB),
                         # top right, time series
                         c(ShcB+ShdB/2, ShrB-ShBox, SvbB+(SvtB-SvbB)*2/3+SvdB/2, SvtB),
                         c(ShrB-ShBox, ShrB, SvbB+(SvtB-SvbB)*2/3+SvdB/2, SvtB),
                         # center left, time series
                         c(ShlB,ShcB-ShdB/2-ShBox, SvbB+(SvtB-SvbB)*1/3+SvdB/2, SvbB+(SvtB-SvbB)*2/3-SvdB/2),
                         c(ShcB-ShdB/2-ShBox, ShcB-ShdB/2, SvbB+(SvtB-SvbB)*1/3+SvdB/2, SvbB+(SvtB-SvbB)*2/3-SvdB/2),
                         # center right, time series
                         c(ShcB+ShdB/2, ShrB-ShBox, SvbB+(SvtB-SvbB)*1/3+SvdB/2, SvbB+(SvtB-SvbB)*2/3-SvdB/2),
                         c(ShrB-ShBox, ShrB, SvbB+(SvtB-SvbB)*1/3+SvdB/2, SvbB+(SvtB-SvbB)*2/3-SvdB/2),
                         # bottom left, time series
                         c(ShlB,ShcB-ShdB/2-ShBox, SvbB, SvbB+(SvtB-SvbB)*1/3-SvdB/2),
                         c(ShcB-ShdB/2-ShBox, ShcB-ShdB/2, SvbB, SvbB+(SvtB-SvbB)*1/3-SvdB/2),
                         # bottom right, time series
                         c(ShcB+ShdB/2, ShrB-ShBox, SvbB, SvbB+(SvtB-SvbB)*1/3-SvdB/2),
                         c(ShrB-ShBox, ShrB, SvbB, SvbB+(SvtB-SvbB)*1/3-SvdB/2)
      ))
      iScreen = 1
      
      # plot data: make legend ----
      # plot(c(0,1), c(0,1), axes = FALSE, ann = FALSE, type = 'n')
      plot(c(0,1), c(0,1), xaxt = 'n', yaxt = 'n', ann = FALSE, type = 'n')
      
      legend('left', legend = c('GO03', 'SP13', 'OV14', '', '', '  year 2008'),
             col = c('cyan', 'orange', 'darkviolet', 'red', 'white', 'white', 'white'), lwd = 2, 
             lty = NA, pch = c(19, 1, 8, NA, NA, NA),
             bg = 'white', horiz = TRUE, inset = 0.02,
             pt.cex = 2, seg.len = 0.5, text.width = 0.15, bty = 'n')
      
      for(iMode in c('ATKN','ACC','COR')) {
        iSpec = paste(iType, iMode, sep = '')
        if(is.null(yScale[[iSpec]])) myScale = 1 else myScale = yScale[[iSpec]]
        
        myMax = 0
        for (iMon in MONs) {
          for(iScen in SCENs) {
            myMax = max(myMax, max(make_daily_mean(valSIM[[iMon]][[iScen]][[iSpec]][,iLoc] * myScale), na.rm = TRUE))
          }
        }
        myLim = getYlim(myMax, 3)
        if(!is.null(yMaxVals[[iSpec]])) myLim = yMaxVals[[iSpec]]
        
        #for(iMon in c('win2008', 'win2008')) {
        for(iMon in MONs) {
          refDate=2008001
          strYear='2008'
          if(iMon == 'sum2008') {
            nT = 61
            from = 2008183
            to = 2008243
          } else if(iMon == 'win2008') {
            nT = 60
            from = 2008001
            to = 2008060
          }
  
          # plot data: prepare data ----
          timeAxis = as.POSIXct((0:(nT) + (from-refDate))*3600*24, tz = 'UTC', origin = "2008-01-01 00:00:00")
          # timeAxis = as.POSIXct((0:(nT-1) + (from-refDate))*3600*24, tz = 'UTC', origin = "2008-01-01 00:00:00")
          
          # alternative: colMeans(array(ARRAY, dim = c(24,91)), na.rm = TRUE)
          pltSIMbase = make_daily_mean(valSIM[[iMon]][['base']][[iSpec]][1:(nT*24),iLoc]) * myScale
          pltSIMsp13 = make_daily_mean(valSIM[[iMon]][['sp13.corr']][[iSpec]][1:(nT*24),iLoc]) * myScale
          pltSIMov14 = make_daily_mean(valSIM[[iMon]][['ov14.corr']][[iSpec]][1:(nT*24),iLoc]) * myScale
        
          myMax = max(c(max(pltSIMbase),max(pltSIMsp13),max(pltSIMov14)))
          
          # if(iSpec == 'MASSATKN') browser()
          
          # plot data: start plotting ----
          iScreen = iScreen + 1 
          
          # print(paste(iMon, iSpec, iLoc, length(pltSIMbase), length(timeAxis)))
          
          screen(iScreen)
          plot(timeAxis[-nT-1], pltSIMbase,
               type = 'n', ann = FALSE, ylim = c(0,myLim),
               yaxt = 'n', xaxt = 'n')
        
          if ((iScreen-1)%%2 == 1) axis(2, las = 2)
        
          yTicksWin = c(1199145600, 1201824000, 1204329600, 1207008000)
          yTicksSum = c(1215043200, 1217721600, 1220400000, 1222992000)
          if(iScreen %in% c(2, 6, 10)) axis(1,at = yTicksWin, labels = FALSE, tck = -0.03)
          if(iScreen == 10) axis(1,at = (yTicksWin[-1]+yTicksWin[-4])/2, tick = FALSE, labels = c('Jan', 'Feb', 'Mar'))
          if(iScreen %in% c(4, 8, 12)) axis(1,at = yTicksSum, labels = FALSE, tck = -0.03) # 1212278400, 1214870400, 1217548800, 1220227200
          if(iScreen == 12) axis(1,at = (yTicksSum[-1]+yTicksSum[-4])/2, tick = FALSE, labels = c('Jul', 'Aug', 'Sept'))
          # if((iScreen-1)%%2 == 0) mtext(yAxisLab[[iSpec]],2, line = 1)
          if(iScreen == 6) mtext(yAxisLab[[paste(iType, 'T', sep = '')]],2, line = 3.8)
          # if ((iScreen-1)%%4 == 1) title(iSpec, line = -1)
          if ((iScreen-1)%%4 == 3) title(rowAxisTxt[[iMode]], line = -1)
          # if ((iScreen-1)%%4 == 3) title(paste('location ', iStat, ',  ',
          #                                      paste('open=',formatC(valOpen[myCells[[iStat]]$x, myCells[[iStat]]$y]*100, format = 'f', width = 5, digits = 2),
          #                                            '%,  surf=',formatC(valSurf[myCells[[iStat]]$x, myCells[[iStat]]$y]*100, format = 'f', width = 5, digits = 2),
          #                                            '%', sep = ''), 
          #                                      sep = ''), line = -1)
          
          points(colMeans(rbind(timeAxis[-1],timeAxis[-nT-1])), pltSIMbase,
                 col = 'cyan', pch = 19, cex = 0.8)
          points(colMeans(rbind(timeAxis[-1],timeAxis[-nT-1])), pltSIMsp13,
                 col = 'orange', pch = 1, cex = 0.8)
          points(colMeans(rbind(timeAxis[-1],timeAxis[-nT-1])), pltSIMov14,
                 col = 'darkviolet', pch = 8, cex = 0.8)
          
          iScreen = iScreen + 1 
          screen(iScreen)
          # NOTE: [,!is.na(pltOBS)] makes that only values are considered which
          #       are available as observations and measurements.
          boxplot(apply(rbind(pltSIMbase, pltSIMsp13, pltSIMov14), MARGIN = 1, FUN = quantile, probs = c(0, 0.25, 0.5, 0.75, 1.0), na.rm = TRUE),
                  yaxt = 'n', xaxt = 'n', xlab = '', ylab = '', ylim = c(0,myLim), border = c('cyan', 'orange', 'darkviolet'), range = 0)
          points(1:3, apply(rbind(pltSIMbase, pltSIMsp13, pltSIMov14), MARGIN = 1, FUN = mean, na.rm = TRUE),
                 pch = 18, col = c('cyan', 'orange', 'darkviolet'))
        }
      }
      close.screen(all.screens = TRUE)
      dev.off()
    }
  }
  
}




# plot box plots ----
if(boxPlots) {  
  # plot box plots: define output file type ----
  # postscript(file = paste('CONC.timeseries.', setup, '.ps', sep = ''), onefile=TRUE,
  #            horizontal = FALSE, paper = 'special', width = 10, height = 6.5)
  
  # par(mar = c(0,0,0,0)+0, 
  #     mgp = c(1.5,0.5,0.0))
  
  rowAxisTxt = list('ATKN'='Aitken mode', 'ACC' = 'accumulation mode', 'COR' = 'coarse mode')
  colAxisTxt = list('NUM'='number', 'SRF' = 'surface area', 'MASS' = 'mass')
  yAxisLab = list('NUMATKN' = expression('Atkn. mode particle number flux ['*10^19 ~ 'particles/d]'),
                  'NUMACC' = expression('acc. mode particle number flux ['*10^19 ~ 'particles/d]'),
                  'NUMCOR' = expression('coarse mode particle number flux ['*10^19 ~ 'particles/d]'),
                  'NUMT' = expression('particle number flux ['*10^19 ~ 'particles/d]'),
                  'SRFATKN' = expression('Atkn. mode particle surface flux [m^2/d]'),
                  'SRFACC' = expression('acc. mode particle surface flux [m^2/d]'),
                  'SRFCOR' = expression('coarse mode particle surface flux [m^2/d]'),
                  'SRFT' = expression('particle surface flux [m^2/d]'),
                  'MASSATKN' = expression('Atkn. mode particle mass flux [t/d]'),
                  'MASSACC' = expression('acc. mode particle mass flux [t/d]'),
                  'MASSCOR' = expression('coarse mode particle mass flux [t/d]'),
                  'MASST' = expression('particle mass flux [t/d]'))
  yUnit = list('NUM' = expression('['*10^19 ~ 'particles/d]'),
               'SRF' = expression('[m'^2*'/d]'),
               'MASS' = expression('[t/d]'))
  yScale = list('NUMATKN' = 8.64*10^-15, 'NUMACC' = 8.64*10^-15, 'NUMCOR' = 8.64*10^-15, 'NUMT' = 8.64*10^-15, 
                'SRFATKN' = 1, 'SRFACC' = 1, 'SRFCOR' = 1, 'SRFT' = 1, 
                'MASSATKN' = 0.0864, 'MASSACC' = 0.0864, 'MASSCOR' = 0.0864, 'MASST' = 0.0864)
  # yMaxVals = list('NUMATKN' = 80, 'NUMACC' = 10, 'NUMCOR' = 1, 'NUMT' = 10, 
  #                 'MASSATKN' = 0.1, 'MASSACC' = 2, 'MASSCOR' = 140, 'MASST' = 140)
  yMaxVals = list('NUMATKN' = 20, 'NUMACC' = 15, 'NUMCOR' = 2.2, 'NUMT' = 10, 
                  'SRFATKN' = 18, 'SRFACC' = 300, 'SRFCOR' = 2000, 'SRFT' = 1, 
                  'MASSATKN' = 0.03, 'MASSACC' = 4, 'MASSCOR' = 400, 'MASST' = 140)
  
  for(iLoc in 1:3){
    iStat = myStations[[iLoc]]
    myLoc = myCells[[iStat]]
    
    postscript(file = paste('SSEMIS.boxplots', setup, iStat, 
                            gsub('([0-9]{2}).([0-9]{2})', 'x\\1y\\2', paste(unlist(myLoc), collapse = '.')),
                            'ps', sep = '.'), onefile=TRUE,
               horizontal = FALSE, paper = 'special', width = 6, height = 8)
    
    par(mar = c(0,0,0,0)+0.0, 
        mgp = c(1.5,0.5,0.0))
    
      
    # plot box plots: define screens ----
    ShlB = 0.1 # left
    ShrB = 0.99 # right
    ShdB = 0.06 # Abstand
    SvtB = 0.88 # top
    SvbB = 0.05 # bottom
    SvdB = 0.015 # Abstand
    ShBox = 0.06
    
    ShcB = ShlB+(ShrB-ShlB)*3/6 # center
    ShwB = ShrB-ShlB # width
    ShwP = (ShwB - 2*ShdB)/3 # plot width
    SvH = 1 - SvtB - ShdB # vertical header height
    
    Sv0a = SvdB
    Sv0b = SvbB - SvdB
    Sv1 = SvbB
    Sv2 = SvbB+(SvtB-SvbB)*1/3-SvdB/2
    Sv3 = SvbB+(SvtB-SvbB)*1/3+SvdB/2
    Sv4 = SvbB+(SvtB-SvbB)*2/3-SvdB/2
    Sv5 = SvbB+(SvtB-SvbB)*2/3+SvdB/2
    Sv6 = SvtB
    # Sv7 = SvtB+SvdB
    # Sv8 = 1.0 - SvdB - 2*SvH/3
    # Sv9 = 1.0 - SvdB - 2*SvH/3
    Sv9 = SvtB+SvdB
    Sv10 = 1.0 - SvdB - SvH*0.6
    Sv11 = 1.0 - SvdB - SvH*0.6
    Sv12 = 1.0 - SvdB
    
    Sv1p1 = ShlB
    Sv1p2 = ShlB + 0.5*ShwP
    Sv1p3 = ShlB +     ShwP
    Sv2p1 = ShlB +     ShwP +   ShdB
    Sv2p2 = ShlB + 1.5*ShwP +   ShdB
    Sv2p3 = ShlB +   2*ShwP +   ShdB
    Sv3p1 = ShlB +   2*ShwP + 2*ShdB
    Sv3p2 = ShlB + 2.5*ShwP + 2*ShdB
    Sv3p3 = ShrB
      
    split.screen(rbind(c(ShlB,ShrB, Sv11, Sv12), # legend row
                       # top heading
                       c(Sv1p1,Sv1p3,  Sv9, Sv10),
                       c(Sv2p1,Sv2p3,  Sv9, Sv10),
                       c(Sv3p1,Sv3p3,  Sv9, Sv10),
#                        # minor heading
#                        c(Sv1p1, Sv1p2, Sv7, Sv8),
#                        c(Sv1p2, Sv1p3, Sv7, Sv8),
#                        c(Sv2p1, Sv2p2, Sv7, Sv8),
#                        c(Sv2p2, Sv2p3, Sv7, Sv8),
#                        c(Sv3p1, Sv3p2, Sv7, Sv8),
#                        c(Sv3p2, Sv3p3, Sv7, Sv8),
                       # top row
                       c(Sv1p1, Sv1p2, Sv5, Sv6),
                       c(Sv1p2, Sv1p3, Sv5, Sv6),
                       c(Sv2p1, Sv2p2, Sv5, Sv6),
                       c(Sv2p2, Sv2p3, Sv5, Sv6),
                       c(Sv3p1, Sv3p2, Sv5, Sv6),
                       c(Sv3p2, Sv3p3, Sv5, Sv6),
                       # center row
                       c(Sv1p1, Sv1p2, Sv3, Sv4),
                       c(Sv1p2, Sv1p3, Sv3, Sv4),
                       c(Sv2p1, Sv2p2, Sv3, Sv4),
                       c(Sv2p2, Sv2p3, Sv3, Sv4),
                       c(Sv3p1, Sv3p2, Sv3, Sv4),
                       c(Sv3p2, Sv3p3, Sv3, Sv4),
                       # bottom row
                       c(Sv1p1, Sv1p2, Sv1, Sv2),
                       c(Sv1p2, Sv1p3, Sv1, Sv2),
                       c(Sv2p1, Sv2p2, Sv1, Sv2),
                       c(Sv2p2, Sv2p3, Sv1, Sv2),
                       c(Sv3p1, Sv3p2, Sv1, Sv2),
                       c(Sv3p2, Sv3p3, Sv1, Sv2),
                       # bottom legend
                       c(Sv1p1,Sv1p3,  Sv0a, Sv0b),
                       c(Sv2p1,Sv2p3,  Sv0a, Sv0b),
                       c(Sv3p1,Sv3p3,  Sv0a, Sv0b)
    ))
    iScreen = 1
    
    # plot box plots: make legend ----
    # plot(c(0,1), c(0,1), axes = FALSE, ann = FALSE, type = 'n')
    plot(c(0,1), c(0,1), xaxt = 'n', yaxt = 'n', ann = FALSE, type = 'n')
    
    legend('left', legend = c('GO03', 'SP13', 'OV14', '  year 2008'),
           col = c('cyan', 'orange', 'darkviolet', 'red', 'white'), lwd = c(2,2,2,NA), 
           lty = c(NA, NA, NA, NA), pch = c(19, 19, 19, NA),
           bg = 'white', horiz = TRUE, inset = 0.02,
           pt.cex = 2, seg.len = 0.5, text.width = 0.2, bty = 'n')
    
    for(iType in c('NUM', 'SRF', 'MASS')) {
      iScreen = iScreen + 1
      screen(iScreen)
      plot(c(0,1), c(0,1), xaxt = 'n', yaxt = 'n', ann = FALSE, type = 'n', axes = FALSE)
      axis(3, at = c(0.5), labels = colAxisTxt[[iType]], tick = FALSE, pos = 0.0, cex.axis = 1.3, font.axis = 2)
      axis(1, at = c(0.25, 0.75), labels = substr(MONs, start = 1, stop = 3), tick = FALSE, pos = 0.4, cex.axis = 1.2)
    }
    
    for(iMode in c('ATKN','ACC','COR')) {
      for(iType in c('NUM', 'SRF', 'MASS')) {
        iSpec = paste(iType, iMode, sep = '')
        if(is.null(yScale[[iSpec]])) myScale = 1 else myScale = yScale[[iSpec]]
        
        myMax = 0
        for (iMon in MONs) {
          for(iScen in SCENs) {
            myMax = max(myMax, max(make_daily_mean(valSIM[[iMon]][[iScen]][[iSpec]][,iLoc] * myScale), na.rm = TRUE))
          }
        }
        myLim = getYlim(myMax, 3)
        if(!is.null(yMaxVals[[iSpec]])) myLim = yMaxVals[[iSpec]]
        
        #for(iMon in c('win2008', 'win2008')) {
        for(iMon in MONs) {
          refDate=2008001
          strYear='2008'
          if(iMon == 'sum2008') {
            nT = 61
            from = 2008183
            to = 2008243
          } else if(iMon == 'win2008') {
            nT = 60
            from = 2008001
            to = 2008060
          }
          
          # plot box plots: prepare data ----
          
          # alternative: colMeans(array(ARRAY, dim = c(24,91)), na.rm = TRUE)
          pltSIMbase = make_daily_mean(valSIM[[iMon]][['base']][[iSpec]][1:(nT*24),iLoc]) * myScale
          pltSIMsp13 = make_daily_mean(valSIM[[iMon]][['sp13.corr']][[iSpec]][1:(nT*24),iLoc]) * myScale
          pltSIMov14 = make_daily_mean(valSIM[[iMon]][['ov14.corr']][[iSpec]][1:(nT*24),iLoc]) * myScale
          
          iScreen = iScreen + 1 
          screen(iScreen)
          # print(iScreen)
          # NOTE: [,!is.na(pltOBS)] makes that only values are considered which
          #       are available as observations and measurements.
          boxplot(apply(rbind(pltSIMbase, pltSIMsp13, pltSIMov14), MARGIN = 1, FUN = quantile, probs = c(0, 0.25, 0.5, 0.75, 1.0), na.rm = TRUE),
                  yaxt = 'n', xaxt = 'n', xlab = '', ylab = '', ylim = c(0,myLim), border = c('cyan', 'orange', 'darkviolet'), range = 0)
          points(1:3, apply(rbind(pltSIMbase, pltSIMsp13, pltSIMov14), MARGIN = 1, FUN = mean, na.rm = TRUE),
                 pch = 18, col = c('cyan', 'orange', 'darkviolet'))
          
          # title(iMon, line = -1)
          # if(iScreen > 16) mtext(iType,1)
        }
        screen(iScreen-1)
        # plot box plots: start plotting ----
        axis(2)
        
#         if(iScreen %in% c(2, 6, 10)) axis(1,at = yTicksWin, labels = FALSE, tck = -0.03)
#         if(iScreen == 10) axis(1,at = (yTicksWin[-1]+yTicksWin[-4])/2, tick = FALSE, labels = c('Jan', 'Feb', 'Mar'))
#         if(iScreen %in% c(4, 8, 12)) axis(1,at = yTicksSum, labels = FALSE, tck = -0.03) # 1212278400, 1214870400, 1217548800, 1220227200
#         if(iScreen == 12) axis(1,at = (yTicksSum[-1]+yTicksSum[-4])/2, tick = FALSE, labels = c('Jul', 'Aug', 'Sept'))
#         # if((iScreen-1)%%2 == 0) mtext(yAxisLab[[iSpec]],2, line = 1)
#         if(iScreen == 6) mtext(yAxisLab[[iSpec]],2, line = 1.6)
#         if ((iScreen-1)%%4 == 1) title(iSpec, line = -1)
#         if ((iScreen-1)%%4 == 3) title(paste('location ', iStat, ',  ',
#                                              paste('open=',formatC(valOpen[myCells[[iStat]]$x, myCells[[iStat]]$y]*100, format = 'f', width = 5, digits = 2),
#                                                    '%,  surf=',formatC(valSurf[myCells[[iStat]]$x, myCells[[iStat]]$y]*100, format = 'f', width = 5, digits = 2),
#                                                    '%', sep = ''), 
#                                              sep = ''), line = -1)
      }
      screen(iScreen-5)
      mtext(rowAxisTxt[[iMode]], 2, line = 1.6, font = 2, cex = 1.3)
      
    }
    
    
    for(iType in c('NUM', 'SRF', 'MASS')) {
      iScreen = iScreen + 1
      screen(iScreen)
      plot(c(0,1), c(0,1), xaxt = 'n', yaxt = 'n', ann = FALSE, type = 'n', axes = FALSE)
      mtext(yUnit[[iType]],1, line = -1)
    }
    close.screen(all.screens = TRUE)
    dev.off()
  }
  
}




# plot publication plots ----
if(pubPlots) {  
  # plot publication plots: define output file type ----
  # postscript(file = paste('CONC.timeseries.', setup, '.ps', sep = ''), onefile=TRUE,
  #            horizontal = FALSE, paper = 'special', width = 10, height = 6.5)
  
  # par(mar = c(0,0,0,0)+0, 
  #     mgp = c(1.5,0.5,0.0))
  
  rowAxisTxt = list('ATKN'='Aitken mode', 'ACC' = 'accum. mode', 'COR' = 'coarse mode')
  colAxisTxt = list('NUM'='number', 'SRF' = 'surface area', 'MASS' = 'mass')
  yAxisLab = list('NUMATKN' = expression('Atkn. mode particle number flux ['*10^19 ~ 'particles/d]'),
                  'NUMACC' = expression('acc. mode particle number flux ['*10^19 ~ 'particles/d]'),
                  'NUMCOR' = expression('coarse mode particle number flux ['*10^19 ~ 'particles/d]'),
                  'NUMT' = expression('particle number flux ['*10^19 ~ 'particles/d]'),
                  'NUM' = expression('number flux ['*10^19 ~ 'particles/d]'),
                  'SRFATKN' = expression('Atkn. mode particle surface area flux [m^2/d]'),
                  'SRFACC' = expression('acc. mode particle surface area flux [m^2/d]'),
                  'SRFCOR' = expression('coarse mode particle surface area flux [m^2/d]'),
                  'SRFT' = expression('particle surface area flux [m'^2*'/d]'),
                  'SRF' = expression('surface area flux [m'^2*'/d]'),
                  'MASSATKN' = expression('Atkn. mode particle mass flux [t/d]'),
                  'MASSACC' = expression('acc. mode particle mass flux [t/d]'),
                  'MASSCOR' = expression('coarse mode particle mass flux [t/d]'),
                  'MASST' = expression('particle mass flux [t/d]'),
                  'MASS' = expression('mass flux [t/d]'))
  yUnit = list('NUM' = expression('['*10^19 ~ 'particles/d]'),
               'SRF' = expression('[m'^2*'/d]'),
               'MASS' = expression('[t/d]'))
  yScale = list('NUMATKN' = 8.64*10^-15, 'NUMACC' = 8.64*10^-15, 'NUMCOR' = 8.64*10^-15, 'NUMT' = 8.64*10^-15, 
                'SRFATKN' = 1, 'SRFACC' = 1, 'SRFCOR' = 1, 'SRFT' = 1, 
                'MASSATKN' = 0.0864, 'MASSACC' = 0.0864, 'MASSCOR' = 0.0864, 'MASST' = 0.0864)
  # yMaxVals = list('NUMATKN' = 80, 'NUMACC' = 10, 'NUMCOR' = 1, 'NUMT' = 10, 
  #                 'MASSATKN' = 0.1, 'MASSACC' = 2, 'MASSCOR' = 140, 'MASST' = 140)
  yMaxVals = list('NUMATKN' = 20, 'NUMACC' = 15, 'NUMCOR' = 2.2, 'NUMT' = 10, 
                  'SRFATKN' = 18, 'SRFACC' = 300, 'SRFCOR' = 2000, 'SRFT' = 1, 
                  'MASSATKN' = 0.03, 'MASSACC' = 4, 'MASSCOR' = 400, 'MASST' = 140)
  
  for(iLoc in c(1)) {
  # for(iLoc in 1:3){
    iStat = myStations[[iLoc]]
    myLoc = myCells[[iStat]]
    
    for(iType in c('NUM', 'SRF', 'MASS')) {
      
      # postscript(file = paste('SSEMIS.boxplots.pub', setup, iType, iStat, 
      #                         gsub('([0-9]{2}).([0-9]{2})', 'x\\1y\\2', paste(unlist(myLoc), collapse = '.')),
      #                         'ps', sep = '.'), onefile=TRUE,
      #            horizontal = FALSE, paper = 'special', width = 6, height = 3.25)
      pdf(file = paste(paste('fig06to08_SSEMIS_boxplots_pub', sub('.', '_', setup, fixed = TRUE), iType, iStat, 
                              gsub('([0-9]{2}).([0-9]{2})', 'x\\1y\\2', paste(unlist(myLoc), collapse = '_')),
                              sep = '_'), 'pdf', sep = '.'), onefile=TRUE,
                 paper = 'special', width = 6, height = 3.25)
      
      par(mar = c(0,0,0,0)+0.0, 
          mgp = c(1.5,0.5,0.0))
      
      
      # plot publication plots: define screens ----
      ShlB = 0.1 # left
      ShrB = 0.99 # right
      ShdB = 0.06 # Abstand
      SvtB = 0.74 # top
      SvbB = 0.03 # bottom
      SvdB = 0.015 # Abstand
      ShBox = 0.06
      
      ShcB = ShlB+(ShrB-ShlB)*3/6 # center
      ShwB = ShrB-ShlB # width
      ShwP = (ShwB - 2*ShdB)/3 # plot width
      SvH = 1 - SvtB - ShdB # vertical header height
      
      Sv1 = SvbB
      Sv6 = SvtB
      # Sv7 = SvtB+SvdB
      # Sv8 = 1.0 - SvdB - 2*SvH/3
      # Sv9 = 1.0 - SvdB - 2*SvH/3
      Sv9 = SvtB+SvdB
      Sv10 = 1.0 - SvdB - SvH*0.45
      Sv11 = 1.0 - SvdB - SvH*0.45
      Sv12 = 1.0 - SvdB
      
      Sv1p1 = ShlB
      Sv1p2 = ShlB + 0.5*ShwP
      Sv1p3 = ShlB +     ShwP
      Sv2p1 = ShlB +     ShwP +   ShdB
      Sv2p2 = ShlB + 1.5*ShwP +   ShdB
      Sv2p3 = ShlB +   2*ShwP +   ShdB
      Sv3p1 = ShlB +   2*ShwP + 2*ShdB
      Sv3p2 = ShlB + 2.5*ShwP + 2*ShdB
      Sv3p3 = ShrB
      
      split.screen(rbind(c(ShlB,ShrB, Sv11, Sv12), # legend row
                         # top heading
                         c(Sv1p1,Sv1p3,  Sv9, Sv10),
                         c(Sv2p1,Sv2p3,  Sv9, Sv10),
                         c(Sv3p1,Sv3p3,  Sv9, Sv10),
                         #                        # minor heading
                         #                        c(Sv1p1, Sv1p2, Sv7, Sv8),
                         #                        c(Sv1p2, Sv1p3, Sv7, Sv8),
                         #                        c(Sv2p1, Sv2p2, Sv7, Sv8),
                         #                        c(Sv2p2, Sv2p3, Sv7, Sv8),
                         #                        c(Sv3p1, Sv3p2, Sv7, Sv8),
                         #                        c(Sv3p2, Sv3p3, Sv7, Sv8),
                         # top row
                         c(Sv1p1, Sv1p2, Sv1, Sv6),
                         c(Sv1p2, Sv1p3, Sv1, Sv6),
                         c(Sv2p1, Sv2p2, Sv1, Sv6),
                         c(Sv2p2, Sv2p3, Sv1, Sv6),
                         c(Sv3p1, Sv3p2, Sv1, Sv6),
                         c(Sv3p2, Sv3p3, Sv1, Sv6),
                         # letter top left
                         c((1-Sv12), ShlB-(1-Sv12)*2, Sv9, Sv12)
      ))
      iScreen = 1
      
      # plot publication plots: make legend ----
      # plot(c(0,1), c(0,1), axes = FALSE, ann = FALSE, type = 'n')
      plot(c(0,1), c(0,1), xaxt = 'n', yaxt = 'n', ann = FALSE, type = 'n')
      
      legend('left', legend = c('GO03', 'SP13', 'OV14', '  year 2008'),
             col = c('cyan', 'orange', 'darkviolet', 'red', 'white'), lwd = c(2,2,2,NA), 
             lty = c(NA, NA, NA, NA), pch = c(19, 19, 19, NA),
             bg = 'white', horiz = TRUE, inset = 0.02,
             pt.cex = 2, seg.len = 0.5, text.width = 0.2, bty = 'n')
      
      for(iMode in c('ATKN','ACC','COR')) {
        iScreen = iScreen + 1
        screen(iScreen)
        plot(c(0,1), c(0,1), xaxt = 'n', yaxt = 'n', ann = FALSE, type = 'n', axes = FALSE)
        axis(3, at = c(0.5), labels = rowAxisTxt[[iMode]], tick = FALSE, pos = 0.1, cex.axis = 1.3, font.axis = 2)
        axis(1, at = c(0.25, 0.75), labels = substr(MONs, start = 1, stop = 3), tick = FALSE, pos = 0.55, cex.axis = 1.2)
        # mtext(rowAxisTxt[[iMode]], 2, line = 1.6, font = 2, cex = 1.3)
      }
      
      for(iMode in c('ATKN','ACC','COR')) {
        iSpec = paste(iType, iMode, sep = '')
        if(is.null(yScale[[iSpec]])) myScale = 1 else myScale = yScale[[iSpec]]
        
        myMax = 0
        for (iMon in MONs) {
          for(iScen in SCENs) {
            myMax = max(myMax, max(make_daily_mean(valSIM[[iMon]][[iScen]][[iSpec]][,iLoc] * myScale), na.rm = TRUE))
          }
        }
        myLim = getYlim(myMax, 3)
        if(!is.null(yMaxVals[[iSpec]])) myLim = yMaxVals[[iSpec]]
        
        #for(iMon in c('win2008', 'win2008')) {
        for(iMon in MONs) {
          refDate=2008001
          strYear='2008'
          if(iMon == 'sum2008') {
            nT = 61
            from = 2008183
            to = 2008243
          } else if(iMon == 'win2008') {
            nT = 60
            from = 2008001
            to = 2008060
          }
          
          # plot publication plots: prepare data ----
          
          # alternative: colMeans(array(ARRAY, dim = c(24,91)), na.rm = TRUE)
          pltSIMbase = make_daily_mean(valSIM[[iMon]][['base']][[iSpec]][1:(nT*24),iLoc]) * myScale
          pltSIMsp13 = make_daily_mean(valSIM[[iMon]][['sp13.corr']][[iSpec]][1:(nT*24),iLoc]) * myScale
          pltSIMov14 = make_daily_mean(valSIM[[iMon]][['ov14.corr']][[iSpec]][1:(nT*24),iLoc]) * myScale
          
          iScreen = iScreen + 1 
          screen(iScreen)
          # print(iScreen)
          # NOTE: [,!is.na(pltOBS)] makes that only values are considered which
          #       are available as observations and measurements.
          boxplot(apply(rbind(pltSIMbase, pltSIMsp13, pltSIMov14), MARGIN = 1, FUN = quantile, probs = c(0, 0.25, 0.5, 0.75, 1.0), na.rm = TRUE),
                  yaxt = 'n', xaxt = 'n', xlab = '', ylab = '', ylim = c(0,myLim), border = c('cyan', 'orange', 'darkviolet'), range = 0)
          points(1:3, apply(rbind(pltSIMbase, pltSIMsp13, pltSIMov14), MARGIN = 1, FUN = mean, na.rm = TRUE),
                 pch = 18, col = c('cyan', 'orange', 'darkviolet'))
          
          # title(iMon, line = -1)
          # if(iScreen > 16) mtext(iType,1)
        }
        screen(iScreen-1)
        # plot publication plots: start plotting ----
        axis(2)
        
        # if(iScreen %in% c(2, 6, 10)) axis(1,at = yTicksWin, labels = FALSE, tck = -0.03)
        # if(iScreen == 10) axis(1,at = (yTicksWin[-1]+yTicksWin[-4])/2, tick = FALSE, labels = c('Jan', 'Feb', 'Mar'))
        # if(iScreen %in% c(4, 8, 12)) axis(1,at = yTicksSum, labels = FALSE, tck = -0.03) # 1212278400, 1214870400, 1217548800, 1220227200
        # if(iScreen == 12) axis(1,at = (yTicksSum[-1]+yTicksSum[-4])/2, tick = FALSE, labels = c('Jul', 'Aug', 'Sept'))
        # # if((iScreen-1)%%2 == 0) mtext(yAxisLab[[iSpec]],2, line = 1)
        # if(iScreen == 6) mtext(yAxisLab[[iSpec]],2, line = 1.6)
        # if ((iScreen-1)%%4 == 1) title(iSpec, line = -1)
        # if ((iScreen-1)%%4 == 3) title(paste('location ', iStat, ',  ',
        #                                      paste('open=',formatC(valOpen[myCells[[iStat]]$x, myCells[[iStat]]$y]*100, format = 'f', width = 5, digits = 2),
        #                                            '%,  surf=',formatC(valSurf[myCells[[iStat]]$x, myCells[[iStat]]$y]*100, format = 'f', width = 5, digits = 2),
        #                                            '%', sep = ''), 
        #                                      sep = ''), line = -1)
      }
      screen(5)
      # mtext(yUnit[[iType]],2, line = 1)
      mtext(yAxisLab[[iType]],2, line = 1.5)
      
      screen(11)
      plot(c(0,1), c(0,1), xaxt = 'n', yaxt = 'n', ann = FALSE, type = 'n', bty = 'n')
      legend('topleft', legend = '', bg = 'white', x.intersp = 0, y.intersp = 0.2, 
             cex = 1.5, title = 'g)', box.lwd = 1, bty = 'n')
      
      close.screen(all.screens = TRUE)
      dev.off()
    }
  }
  
}



# write out data for supplement ----
if(writeOutData) {
  mySpec = paste(rep(c('NUM', 'SRF', 'MASS'), each = 3), rep(c('ATKN','ACC','COR'), 3), sep = '')
  nSpec = 9
  headings = append(c('doy', 'hour'), mySpec)
  iPos = 1
  
  
  for(iMon in MONs) {
    if(iMon == 'sum2008') {
      nT = 61*24
      from = 2008183
      to = 2008243
    } else if(iMon == 'win2008') {
      nT = 60*24
      from = 2008001
      to = 2008060
    }
    nDays = nT/24
    
    for(iScen in SCENs) {
      print(paste(iMon, iScen))
      fOut = paste('ssemis.timeseries.values', iMon, iScen, 'oneLocD','csv', sep = '.')
      
      tmpOut = array(0.0, dim = c(nT,nSpec+2))
      tmpOut[,1] = rep(seq(from, length.out = nDays), each = 24)
      tmpOut[,2] = rep(0:23, nDays)
      
      for (iSpec in 1:nSpec) {
        strSpec = mySpec[iSpec]
        tmpOut[,iSpec+2] = valSIM[[iMon]][[iScen]][[strSpec]][1:nT,iPos]
      }
      write.table(tmpOut, fOut, col.names = headings, row.names = FALSE, sep = ',')
    }
  }
}