#' ssemis_versioning
#' 
#' This script is part of a sea salt emissions calculation programme. The programme
#' calculates sea salt emissions according to the sea salt emission function by 
#' Ovadnevaite et al. (2014) and Spada et al. (2013). This script provides the 
#' current version number of the code.
#' 
#' @author Daniel Neumann, daniel.neumann@hzg.de
#' @date 2015-Nov-06
#' @version 4.0.1
#' Version description: Same functions as version 3.0.0. Optimised programme
#'  structure by reduction of for loops and compiled functions. Since version
#'  3.6.0 some more functions were compiled and shortened. Since version 3.6.5 
#'  emissions of Gong2003 were added. In version 3.9.0 the versioning procedure
#'  and some internal naming conventions were changed. OV14 was accidently 
#'  denoted as OV13 in earlier versions. It was correct in v3.9.0. Version 
#'  4.0.0 removes much things which were set to deprecated in v3.9.0 and 
#'  finalizes the corrections from OV13 to OV14.

ssemis_version = '4.0.1'

