#' Adapted from MATLAB code by Mostafa H. Sharqawy (2010). 
#' @keywords sea water, salinity, sst, viscosity, density
#' @author Daniel Neumann, daniel.neumann@hzg.de
#' @version 1.0
#' @date 2015-10-16
#' @references http://web.mit.edu/seawater/ , dx.doi.org/10.5004/dwt.2010.1079
#' 
#' References:
#' Sharqawy, M. H.; Lienhard, J. H. & Zubair, S. M. Thermophysical properties 
#'    of seawater: a review of existing correlations and data Desalination and
#'    Water Treatment, 2010, 16, 354-380
#'    

#' NOTE:
#'  - This script should be source with chdir = TRUE:
#'     source('SOME_DIR/SW_tools.R', chdir = TRUE)
#'  - The other MATLAB files are not converted, yet.

source('SWdensity.R')
source('SWviscosity.R')
source('SWkviscosity.R')