#!/bin/bash

# TODO
# @author Daniel Neumann, daniel.neumann@hzg.de
# @date 2015-10-09

# set directories
cd /media/neumannd/work_mn/66_Tools/pub_neumannd2016a
DATADIR='01_data'
PICDIR='05_maps'
fileName='figS01_cmaq_input_sulfStudy'

# set gmt parameters
gmtdefaults -D > .gmtdefaults4
gmtset MAP_ORIGIN_X 3c MAP_ORIGIN_Y 2.0c
#gmtset MAP_ORIGIN_X 3c MAP_ORIGIN_Y 9.0c
#gmtset HEADER_FONT_SIZE 16p
gmtset FONT_TITLE 14p
gmtset FONT_LABEL 20p
gmtset FONT_ANNOT_PRIMARY 18p
# Label with -/+:
gmtset FORMAT_GEO_MAP ddd:mm:ss
#Labels with East and West

# parameters
echo "Creating Map" 
WEST=-10.0
EAST=35.0
SOUTH=40.0
NORTH=68.0
DLON=10.0 # dx
DLAT=5.0 # dy
PARAMS=""

# map
# pscoast -R-10/35/40/68 -JM14 -B10/5 -Glightyellow -Slightblue -Dl > pic.ps
pscoast -R$WEST/$EAST/$SOUTH/$NORTH -JM14 $PARAMS -B$DLON/$DLAT -Glightyellow -Slightblue -Di -K > pic.ps
# compas: -Tf3/64.2/1.0/ 

# data
psxy ${DATADIR}/bsh_no.grid -R -I0.7 -JM14 -W4,255/127/0 -G255/127/0 -O -K >> pic.ps
# lon -4:2:30 to 30:22:30 ; lat 48:34:30 to 65:52:45 ; dlon = 0:5:0 ; dlat = 0:3:0
# but towards Northwest (Atlantic ocean) it goes to -3:27:30 and 60:19:30
# psxy ${DATADIR}/coastDat_WAM.grid -R -I0.7 -JM14 -W4,0/0/255 -G0/0/255 -O -K >> pic.ps
# lon -4:45:00 to 13:15:00 ; lat 50:30:00 to 59:30:00 ; dlon = 0:4:30 ; dlat = 0:3:0
psxy ${DATADIR}/bsh_ku.grid -R -I0.7 -JM14 -W4,255/0/0 -G255/0/0 -O -K >> pic.ps
# lon 6:10:25 to 14:54:35 ; lat 53:13:45 to 56:26:45 ; dlon = 0:0:50 ; dlat = 0:0:30
# psxy ${DATADIR}/coastDat_CCLM.grid -R -I0.7 -JL10.0/55.0/30.0/60.0/20 -O -K >> pic.ps
# todo

# psxy ${DATADIR}/bsh_no.grid -R -I0.7 -JM14 -W4,255/127/0 -O -K >> pic.ps
# psxy ${DATADIR}/coastDat_WAM.grid -R -I0.7 -JM14 -W4,0/0/255 -O -K >> pic.ps
# psxy ${DATADIR}/bsh_ku.grid -R -I0.7 -JM14 -W4,255/0/0 -O -K >> pic.ps


pscoast -R$WEST/$EAST/$SOUTH/$NORTH -JM14 $PARAMS -W1p -Di -Lf-3/66/56/400k+l'km' -O -K >> pic.ps

## LEGEND
# psscale -Cpowersaving.cpt -S -D5/0/10/1ch -B1000:'power savings':/:'low': -Al -X2.2 -Y-2.2 -N -O -K >> pic.ps
#pstext -J -R -O -X0 -Y0 -N -K << EOF >> pic.ps
#-2 49.2 18 0 0 MC high
#EOF

# S 0.1i c 0.15i blue 0.25p 0.2i coastDatII WAM
cat > my.legend << END
S 0.1i c 0.15i 255/0/0 0.25p 0.2i BSHcmod fine
S 0.1i c 0.15i 255/127/0 0.25p 0.2i BSHcmod medium
END
# S 0.1i c 0.15i blue 0.25p 0.2i CD72 (72x72 km2)
# S 0.1i c 0.15i green 0.25p 0.2i CD24 (24x24 km2)
# S 0.1i c 0.15i red 0.25p 0.2i CD06 (6x6 km2)

pslegend my.legend -D-8/41/7/LB -R -JM14 -F+gwhite+p -O >> pic.ps


## convert into other formats
ps2raster -A -Teg -Qt2 pic.ps
mv pic.png ${PICDIR}/$fileName.png
mv pic.eps ${PICDIR}/$fileName.eps
cp pic.ps ${PICDIR}/$fileName.ps

echo 'finished'
